<!-- Content Header (Page header) -->
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h2 class="m-0 fw-bold">REPORTE CUENTAS POR COBRAR</h2>
            </div><!-- /.col -->
            <div class="col-sm-6  d-none d-md-block">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="index.php">Inicio</a></li>
                    <li class="breadcrumb-item active">Reporte Cuentas por Cobrar</li>
                </ol>
            </div><!-- /.col -->
        </div><!-- /.row -->
    </div><!-- /.container-fluid -->
</div>
<!-- /.content-header -->

<!-- Main content -->
<div class="content mb-3">

    <div class="container-fluid">

        <!-- row para criterios de busqueda -->
        <div class="row">

            <div class="col-lg-12">

                <div class="card card-gray shadow">
                    <div class="card-header">
                        <h3 class="card-title">CRITERIOS DE BÚSQUEDA</h3>
                        <div class="card-tools">
                            <button type="button" class="btn btn-tool" data-card-widget="collapse">
                                <i class="fas fa-plus"></i>
                            </button>
                            <button type="button" class="btn btn-tool text-warning" id="btnLimpiarBusqueda">
                                <i class="fas fa-times"></i>
                            </button>
                        </div> <!-- ./ end card-tools -->
                    </div> <!-- ./ end card-header -->
                    <div class="card-body py-2">

                        <div class="row">


                            <!-- <div class="col-12 col-lg-3 mb-2">
                                <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-calendar-alt mr-1 my-text-color"></i> Fecha Desde</label>
                                <input type="text" style="border-radius: 20px;" class="form-control form-control-sm" id="FechaDesde" aria-label="Small" aria-describedby="inputGroup-sizing-sm">
                            </div> -->

                            <!-- FECHA DE COMPRA -->
                            <div class="col-12 col-md-4 col-lg-3 mb-2">
                                <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-calendar-alt mr-1 my-text-color"></i> Fecha Desde</label>
                                <div class="input-group input-group-sm mb-3 ">
                                    <span class="input-group-text" id="inputGroup-sizing-sm" style="cursor: pointer;" data-toggle="datetimepicker" data-target="#fecha_desde"><i class="fas fa-calendar-alt ml-1 text-white"></i></span>
                                    <input type="text" class="form-control form-control-sm datetimepicker-input" style="border-top-right-radius: 20px;border-bottom-right-radius: 20px;" aria-label="Sizing example input" id="fecha_desde" name="fecha_desde" aria-describedby="inputGroup-sizing-sm">
                                </div>
                                <!-- <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-calendar-alt mr-1 my-text-color"></i> Fecha Desde</label>
                                <input type="text" style="border-radius: 20px;" class="form-control form-control-sm" id="FechaDesde" aria-label="Small" aria-describedby="inputGroup-sizing-sm"> -->
                            </div>

                            <div class="col-12 col-lg-3 mb-2">
                                <!-- <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-calendar-alt mr-1 my-text-color"></i> Fecha Hasta</label>
                                <input type="text" style="border-radius: 20px;" class="form-control form-control-sm" id="FechaHasta" aria-label="Small" aria-describedby="inputGroup-sizing-sm"> -->

                                <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-calendar-alt mr-1 my-text-color"></i> Fecha Hasta</label>
                                <div class="input-group input-group-sm mb-3 ">
                                    <span class="input-group-text" id="inputGroup-sizing-sm" style="cursor: pointer;" data-toggle="datetimepicker" data-target="#fecha_hasta"><i class="fas fa-calendar-alt ml-1 text-white"></i></span>
                                    <input type="text" class="form-control form-control-sm datetimepicker-input" style="border-top-right-radius: 20px;border-bottom-right-radius: 20px;" aria-label="Sizing example input" id="fecha_hasta" name="fecha_hasta" aria-describedby="inputGroup-sizing-sm">
                                </div>
                            </div>

                            <div class="col-12 col-lg-6 mb-2">
                                <label class="mb-0 ml-1 text-sm my-text-color"><i class="fas fa-user-tie mr-1 my-text-color"></i>Cliente</label>
                                <input type="text" style="border-radius: 20px;" class="form-control form-control-sm" id="cliente" aria-label="Small" aria-describedby="inputGroup-sizing-sm">
                            </div>

                            <!-- BUSCAR PRODUCTO -->
                            <div class="d-flex align-items-end col-12 col-lg-12 justify-content-center mt-3">

                                <a class="btn btn-sm btn-danger fw-bold w-25" id="btnLimpiarFiltros" style="position: relative;">
                                    <span class="text-button">LIMPIAR</span>
                                    <span class="btn fw-bold icon-btn-danger d-flex align-items-center">
                                        <i class="fas fa-times-circle fs-5"></i>
                                    </span>
                                </a>

                                <a class="btn btn-sm btn-info w-25 fw-bold btnGenerarReporte ml-2" style="position: relative;">
                                    <span class="text-button">GENERAR REPORTE</span>
                                    <span class="btn fw-bold icon-btn-custom d-flex align-items-center">
                                        <i class="fas fa-search fs-5"></i>
                                    </span>
                                </a>
                            </div>


                        </div>

                    </div> <!-- ./ end card-body -->

                </div>

            </div>

        </div>

        <!-- row para criterios de busqueda -->
        <div class="row">

            <div class="col-md-12">

                <table id="tbl_cuentas_por_cobrar" class="shadow border border-secondary w-100 table-striped">
                    <thead class="bg-main" style="font-size:14px;">
                        <tr class="text-center">
                            <th>COD CLIENTE / CLIENTE</th>
                            <th>FACTURA</th>
                            <th>FECHA EMISIÓN</th>
                            <th>FECHA VCTO</th>
                            <th>MONTO TOTAL</th>
                            <th>TOTAL ABONOS</th>
                            <th>SALDO PENDIENTE</th>
                        </tr>
                    </thead>
                    <tbody style="font-size:14px;"></tbody>
                </table>

            </div>

        </div>

    </div>

</div>

<script>
    $(document).ready(function() {

        fnc_InicializarFormulario();

        $(".btnGenerarReporte").on('click', function() {
            fnc_CargarDataTableCuentasPorCobrar($("#fecha_desde").val(), $("#fecha_hasta").val(), $("#cliente").val())
        });

        $("#btnLimpiarFiltros").on('click', function() {
            $("#cliente").val('');
            $("#fecha_desde").val('');
            $("#fecha_hasta").val('');
            fnc_CargarDataTableCuentasPorCobrar('', '', '')
        });

    })

    function fnc_InicializarFormulario() {
        fnc_CargarInputsFecha();
        fnc_CargarAutocompleteClientes();
        fnc_CargarDataTableCuentasPorCobrar('', '', '');
    }

    function fnc_CargarInputsFecha() {
        $('#fecha_desde, #fecha_hasta').datetimepicker({
            format: 'YYYY-MM-DD',
            locale: moment.lang('es', {
                months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'
                    .split('_'),
                monthsShort: 'Enero._Feb._Mar_Abr._May_Jun_Jul._Ago_Sept._Oct._Nov._Dec.'.split(
                    '_'),
                weekdays: 'Domingo_Lunes_Martes_Miercoles_Jueves_Viernes_Sabado'.split('_'),
                weekdaysShort: 'Dom._Lun._Mar._Mier._Jue._Vier._Sab.'.split('_'),
                weekdaysMin: 'Do_Lu_Ma_Mi_Ju_Vi_Sa'.split('_')
            }),
            // defaultDate: moment(),
        });
    }

    /*===================================================================*/
    //A U T O C O M P L E T E   D E   C L I E N T E S
    /*===================================================================*/
    function fnc_CargarAutocompleteClientes() {

        $("#cliente").autocomplete({
            source: "ajax/clientes.ajax.php",
            minLength: 2,
            autoFocus: true,
            select: function(event, ui) {
                $("#cliente").val(ui.item.value.split('-')[1].trim())
                return false;
            },

            response: function(event, ui) {

                if (!ui.content.length) {
                    var noResult = {
                        value: "",
                        label: '<a href="javascript:void(0);" class="d-flex border border-secondary border-left-0 border-right-0 border-top-0" style="width:100% !important;">' +
                            '<div class=""> ' +
                            '<span class="text-sm fw-bold">No existen datos</span>' +
                            '</div>' +
                            '</a>'
                    };
                    ui.content.push(noResult);
                }
            },
            open: function() {
                $("ul.ui-menu").width($(this).innerWidth());
            }
        }).data("ui-autocomplete")._renderItem = function(ul, item) {
            return $("<li class='ui-autocomplete-row'></li>")
                .data("item.autocomplete", item)
                .append(item.label)
                .appendTo(ul);
        };

    }


    /* ======================================================================================
    
    ====================================================================================== */
    function fnc_CargarDataTableCuentasPorCobrar($fecha_desde, $fecha_hasta, $cliente) {

        if ($.fn.DataTable.isDataTable('#tbl_cuentas_por_cobrar')) {
            $('#tbl_cuentas_por_cobrar').DataTable().destroy();
            $('#tbl_cuentas_por_cobrar tbody').empty();
        }

        $("#tbl_cuentas_por_cobrar").DataTable({
            dom: 'Bfrtip',
            buttons: [{
                    extend: 'excel',
                    title: function() {
                        var printTitle = 'REPORTE CUENTAS POR COBRAR';
                        return printTitle
                    }
                },
                // {
                //     extend: 'print',
                //     title: function() {
                //         var printTitle = 'REPORTE DE CUENTAS POR COBRAR';
                //         return printTitle
                //     }
                // }, 
                {
                    text: '<i class="fas fa-file-pdf"></i> Generar PDF',
                    className: 'bg-danger',
                    action: function(e, dt, node, config) {
                        fnc_GenerarPdf($fecha_desde, $fecha_hasta, $cliente);
                    }
                },
                'pageLength'
            ],
            pageLength: 10,
            order: [0, 'desc'],
            ajax: {
                url: 'ajax/reportes.ajax.php?',
                dataSrc: '',
                data: {
                    'accion': 'reporte_cuentas_x_cobrar',
                    'cliente': $cliente,
                    'fecha_desde': $fecha_desde,
                    'fecha_hasta': $fecha_hasta
                },
                type: 'POST'
            },

            scrollX: true,
            columnDefs: [{
                    "className": "dt-center",
                    "targets": "_all"
                },

            ],
            language: {
                url: "//cdn.datatables.net/plug-ins/1.10.20/i18n/Spanish.json"
            }
        })
    }

    function fnc_GenerarPdf($fecha_desde, $fecha_hasta, $cliente) {        

        window.open('https://fact.portalbloggeros.com/vistas/generar_reporte_ctas_x_cobrar_a4.php?cliente=' + $cliente +'&fecha_desde='+$fecha_desde + '&fecha_hasta='+$fecha_hasta,
            'fullscreen=yes' +
            "resizable=0,"
        );

    }
</script>